import * as server from "@minecraft/server"


const world = server.world
const system = server.system
const droneTriggerTypeId = `ax:ender_drone_item`

function normalizeVector(x, y, z) {
  const magnitude = Math.sqrt(x * x + y * y + z * z);

  if (magnitude === 0) {
    // Evitar la división por cero si el vector es el vector nulo
    return { x: 0, y: 0, z: 0 };
  }

  const normalizedX = x / magnitude;
  const normalizedY = y / magnitude;
  const normalizedZ = z / magnitude;

  return { x: normalizedX, y: normalizedY, z: normalizedZ };
}

function getMagnitude(vector) {
    const {x,y,z} = vector
    // Calculate the magnitude (r)
    const r = Math.sqrt(x * x + y * y + z * z);
  
    // Calculate θ (elevation angle) in degrees as 't' in the range [0, 360)
    
    return r
  }

function summonDrone(player){
    const playerUsingDrone = world.scoreboard.getObjective("playerUsingDrone")
    const {dimension, location } = player

    const drone = dimension.spawnEntity(`ax:ender_drone`,player.getHeadLocation())
    playerUsingDrone.setScore(player,1)
    drone.nameTag = player.name
    system.runTimeout(()=>{
        droneControl(drone)
    },5)
    
}

function droneControl(drone) {
    const playerUsingDrone = world.scoreboard.getObjective("playerUsingDrone");
    const playerUsingDroneLaser = world.scoreboard.getObjective("playerUsingDroneLaser");

    /*const enderDroneXRotation = world.scoreboard.getObjective("enderDroneXRotation");
    const enderDroneYRotation = world.scoreboard.getObjective("enderDroneYRotation");
    const enderDroneTargetMagnitude = world.scoreboard.getObjective("enderDroneTargetMagnitude");*/
    const pname = drone.nameTag;
    const player = world.getPlayers({ name: pname })[0];



    
    if (player) {
        const { location } = player;
        const tx = Math.floor(location.x) + 0.5;
        const tz = Math.floor(location.z) + 0.5;
        let targetVector = { x: 0, y: 0, z: 0 };
        let tick = 0
        
        const id = system.runInterval(() => {
            if (player && playerUsingDrone.getScore(player)) {
                
                //const inventory = player.getComponent('inventory').container;
                const itemInHand = player.getComponent('equippable').getEquipment(server.EquipmentSlot.Mainhand)
                
               // try {
                    if (itemInHand?.typeId === droneTriggerTypeId) {
                        const r = player.getRotation();
                        const { x, y } = r;
                        //const vd = player.getViewDirection()
                        
                        
                        
                        /*const x = -Math.atan2(vd.y,Math.sqrt(vd.x*vd.x+vd.z*vd.z))* (180 / Math.PI)
                        const y = -Math.atan2(vd.x,vd.z)* (180 / Math.PI)*/

                        
                        drone.setRotation({x,y});
                        //drone.teleport(drone.location,{keepVelocity: false, rotation: {x,y}})
                        const dl = drone.getHeadLocation();
                        const { x: dx, y: dy, z: dz } = dl;
                        const { dimension } = player;
                        
                       
                        
                        
                        drone.runCommand(`execute anchored eyes run camera ${pname} set minecraft:free ease 0.1 linear pos ^-0.5 ^ ^-1 rot ${x} ${y}`);
                        
                        
                        //drone.runCommand(`camera ${pname} set minecraft:free ease 0.1 linear pos ~ ~10 ~  rot ${x} ${y}`);

                        let target = undefined;
                        let lookBlock = undefined;
                        
                        try {
                            target = drone.getEntitiesFromViewDirection({ maxDistance: 200 })[0]?.entity;
                            lookBlock = drone.getBlockFromViewDirection({ maxDistance: 200 });
                        }
                        catch {
                            console.warn(``);
                        }

                        if(/*(system.currentTick%3)==0*/true){

                        let { x: vx, y: vy, z: vz } = player.getVelocity();
                        //const va = new server.Vector(vx, 0, vz);
                        const vb = normalizeVector(vx,0,vz)
                        
                        if (player.isJumping && !player.isSneaking) {
                            vy = 0.25;
                        } else if (!player.isJumping && player.isSneaking) {
                            vy = -0.25;
                        } else {
                            vy = 0;
                        }
                        
                        drone.clearVelocity();
                        if(playerUsingDroneLaser.getScore(player)){
                            drone.applyImpulse({ x: vb.x * 0.15, y: vy, z: vb.z * 0.15 });
                        }else{
                            
                            drone.applyImpulse({ x: vb.x * 0.5, y: vy, z: vb.z * 0.5 });
                        }
                        
                        player.teleport({ x: tx, y: player.location.y, z: tz });
                        //player.teleport({ x: /*tx*/dx+cx, y: dy+cy/*player.location.y*/, z: dz+cz/*tz*/ });
                        

                        }
                        

                        if (playerUsingDroneLaser.getScore(player)) {
                            if(/*(system.currentTick%3)==0*/true){world.playSound(`ender_drone.laser.loop`,dl,{volume:0.2})}
                            
                            if (target && target.nameTag != pname && target.typeId != `minecraft:item`) {
                                const { location: tl } = target;
                                const { x: tx, y: ty, z: tz } = tl;
                                targetVector = { x: tx - dx, y: ty - dy, z: tz - dz };
                                target.applyDamage(6, { cause: `magic`, damagingEntity: drone });
                                dimension.spawnParticle(`ax:ender_drone_pointer`, target?.location);
                                
                                /*if (!target.hasComponent(`minecraft:fire_immune`) && !target.getEffect(`fire_resistance`)) {
                                    target.setOnFire(10, true);
                                }*/
                            } else if (lookBlock) {
                                const { block, faceLocation } = lookBlock;
                                let { x: bx, y: by, z: bz } = block.location;
                                let { x: px, y: py, z: pz } = faceLocation;
                                targetVector = { x: bx + px - dx, y: by + py - dy, z: bz + pz - dz };
                                dimension.spawnParticle(`ax:ender_drone_pointer`, { x: bx + px, y: by + py, z: bz + pz });
                                //hhhhhdimension.runCommandAsync(`fill ${bx + px} ${by + py} ${bz + pz} ${bx + px} ${by + py} ${bz + pz} fire [] replace air`)
                            } else {
                                targetVector = { x: 0, y: 1000, z: 0 };
                            }
                        } else {
                            targetVector = { x: 0, y: 0, z: 0 };
                        }
                        
                        const m = getMagnitude(targetVector);
                        
                       
                        drone.setProperty(`ax:targetMagnitude`, m); 
                        
                        drone.setProperty(`ax:xRotation`, x);
                        drone.setProperty(`ax:yRotation`, y);
                        
        /*
                        enderDroneTargetMagnitude.setScore(drone,Math.floor(m*1000))
                        enderDroneXRotation.setScore(drone,Math.floor(x*1000))
                        enderDroneYRotation.setScore(drone,Math.floor(y * 1000))
                        drone.triggerEvent(`setProperty`)*/
                    } else {
                        playerUsingDrone.setScore(player, 0);
                    }
                /*} catch {
                    console.warn(``);
                }*/
            } else {
                try {
                    player.camera.clear()
                    player.runCommand(`playanimation @s animation.ender_drone.hide_item a 0.1`)
                } catch {
                    console.warn(``);
                }
                drone.runCommand(`event entity @s despawn`);
                system.clearRun(id);
                player.playSound(`mob.shulker.teleport`)
            }
        },3);
    }else{
        drone.kill()
    }
}

function repairDrones(player){
    const pInventor = player.getComponent(`inventory`).container
    for (let i = 0; i < pInventor.size; i++) {
        let item = pInventor.getItem(i)
        /*
        if(item?.typeId === droneTriggerTypeId && item?.getComponent(`minecraft:durability`).damage){
            const ni =  new server.ItemStack(droneTriggerTypeId)
            const damage = item?.getComponent(`minecraft:durability`).damage
            ni.getComponent(`durability`).damage = item?.getComponent(`minecraft:durability`).damage -1
            pInventor.setItem(i,ni)
            if(damage-1 ==0){
                player.sendMessage(`Your drone has fully recovered`)
            }
        } */
        if(item?.typeId === droneTriggerTypeId /*&& item?.getComponent(`minecraft:durability`).damage*/){
            let damage = undefined
            const lore =  item.getLore()[0]
            if(lore){
                damage = parseInt(lore.replace(`§dCooldown: §e`,``))
            }
            if(damage){
            const ni =  new server.ItemStack(droneTriggerTypeId)
            /*const damage = item?.getComponent(`minecraft:durability`).damage
            ni.getComponent(`durability`).damage = item?.getComponent(`minecraft:durability`).damage -1*/
            const newCooldown = `§dCooldown: §e${damage-1}`
            ni.setLore([newCooldown])
            if(damage-1 ==0){
                player.sendMessage(`Your drone has fully recovered`)
                ni.setLore([])
            }
            pInventor.setItem(i,ni)
            
            }
        }
    }
}
const slots = ["offhand","mainhand","head","chest","legs","feet"]
system.runInterval(()=>{
    world.getPlayers().forEach(player =>{
        
        system.runTimeout(()=>{
            repairDrones(player)
        },10*Math.random())
    })
},20)

system.runInterval(()=>{
    world.getPlayers().forEach(player =>{
        
        const itemInHand = player.getComponent('equippable').getEquipment(server.EquipmentSlot.Mainhand)

        if(itemInHand?.typeId === droneTriggerTypeId){
            let damage = undefined
            const lore =  itemInHand.getLore()[0]
            if(lore){
                damage = parseInt(lore.replace(`§dCooldown: §e`,``))
            }
            if(damage){
                player.onScreenDisplay.setActionBar(lore)
            } 
        }
    })
},5)

world.afterEvents.playerSpawn.subscribe(data => {
    const dimensionIds = [`overworld`,`the_end`,`nether`]
    const playerUsingDrone = world.scoreboard.getObjective("playerUsingDrone")
    const playerUsingDroneLaser = world.scoreboard.getObjective("playerUsingDroneLaser")
    const {player} = data
    playerUsingDrone.setScore(player,0)
    playerUsingDroneLaser.setScore(player,0)
    player.runCommand(`camera @s clear`)
    player.runCommand(`playanimation @s animation.ender_drone.hide_item a 0.1`)

    dimensionIds.forEach(dimension=>{
        dimension.getEntities({type:`ax:ender_drone`,name:player.name}).forEach(entity=>{
            console.warn(entity.nameTag)
            entity.runCommand(`event entity @s despawn`)
        })
    })


})

world.afterEvents.itemUse.subscribe(({itemStack,source})=>{
    const playerUsingDrone = world.scoreboard.getObjective("playerUsingDrone")
    const playerUsingDroneLaser = world.scoreboard.getObjective("playerUsingDroneLaser")
    //itemStack.setLore(["Line 1", "Line 2", "Line 3"])
    //console.warn(itemStack.getComponent(`minecraft:durability`).damage)
   // itemStack.getComponent(`minecraft:durability`).damage = 9999
    if(itemStack.typeId == droneTriggerTypeId && source.typeId === `minecraft:player`){
        let damage = undefined
            const lore =  itemStack.getLore()[0]
            if(lore){
                damage = parseInt(lore.replace(`§dCooldown: §e`,``))
            }

        if(/*!itemStack.getComponent(`durability`).damage*/!damage){
           if(!playerUsingDrone.getScore(source)){
            //source.playAnimation(`animation.ender_drone.hide_item`, {stopExpression: `!query.is_item_name_any('slot.weapon.mainhand', 0, '${droneTriggerTypeId}')`})
            source.runCommand(`playanimation @s animation.ender_drone.hide_item a 999999 \"!query.is_item_name_any('slot.weapon.mainhand', 0, '${droneTriggerTypeId}')\"`)
            summonDrone(source)
            }else{
            if(playerUsingDroneLaser.getScore(source)){
                playerUsingDroneLaser.setScore(source,0)
            }else{
                playerUsingDroneLaser.setScore(source,1)
            }
            }
        }else{
            source.sendMessage(`Wait for your drone to fully repair before using it again`)
        }
    }
})

world.afterEvents.itemReleaseUse.subscribe(({itemStack,source})=>{
   
    const playerUsingDrone = world.scoreboard.getObjective("playerUsingDrone")
    const playerUsingDroneLaser = world.scoreboard.getObjective("playerUsingDroneLaser")
    
    if(source.typeId === `minecraft:player`){
       if(playerUsingDrone.getScore(source) && playerUsingDroneLaser.getScore(source)){
        playerUsingDroneLaser.setScore(source,0)
       }
        
    }
})

/*world.afterEvents.dataDrivenEntityTriggerEvent.subscribe(data => {
    droneControl(data.entity)
  }, { eventTypes: ['cam'] })*/


world.afterEvents.entityDie.subscribe(({damageSource,deadEntity})=>{
    
    if (deadEntity?.typeId===`ax:ender_drone`){
        
        const playerUsingDrone = world.scoreboard.getObjective("playerUsingDrone")
      const playerUsingDroneLaser = world.scoreboard.getObjective("playerUsingDroneLaser")
        
      const player = world.getPlayers({name:deadEntity.nameTag})[0]
      player.playSound(`random.break`)

      
      playerUsingDrone.setScore(player,0)
      playerUsingDroneLaser.setScore(player,0)
      player.runCommand(`camera @s clear`)
      player.runCommand(`playanimation @s animation.ender_drone.hide_item a 0.1`)
      const pEquipment = player.getComponent('equippable')
      const itemInHand = pEquipment.getEquipment(server.EquipmentSlot.Mainhand)
      if(itemInHand?.typeId == `ax:ender_drone_item`){
        const ni =  new server.ItemStack(droneTriggerTypeId)
        ni.setLore([`§dCooldown: §e${360}`])
       /* ni.getComponent(`durability`).damage = 60*/
        
        
        
        pEquipment.setEquipment(server.EquipmentSlot.Mainhand,ni)

      }
      
    }
   
  })
